%define major     12
%define libqs4    %mklibname qscintilla2_ %{major}
%define libqs5    %mklibname qscintilla2-qt5_ %{major}
%define libqs4dev %mklibname qscintilla2 -d
%define libqs5dev %mklibname qscintilla2-qt5 -d

Name:           qscintilla
Version:        2.9.1
Release:        %mkrel 7
Summary:        Port to Qt of Neil Hodgson's Scintilla C++ editor class
License:        GPLv2+
Group:          System/Libraries
URL:            http://www.riverbankcomputing.co.uk/software/qscintilla/intro
Source0:        http://downloads.sourceforge.net/pyqt/QScintilla-gpl-%{version}.tar.gz
Patch0:         QScintilla-gpl-2.9.1-qt5.patch

BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(phonon)
BuildRequires:  sed

# Qt4/Qt5
BuildRequires:  qt4-devel
BuildRequires:  pkgconfig(QtWebKit)
BuildRequires:  qt-assistant-adp-devel
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5PrintSupport)
BuildRequires:  pkgconfig(Qt5Designer)

# Python 2
BuildRequires:  pkgconfig(python2)
BuildRequires:  pkgconfig(dbus-python)
BuildRequires:  python-qt4-devel
BuildRequires:  python-qt5-devel
BuildRequires:  python-sip

# Python 3
BuildRequires:  pkgconfig(python3)
BuildRequires:  python3-dbus
BuildRequires:  python3-qt4-devel
BuildRequires:  python3-qt5-devel
BuildRequires:  python3-sip-devel

%description
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

#--------------------------------------------------------------

%package -n     %{libqs4}
Summary:        Port to Qt4 of Neil Hodgson's Scintilla C++ editor class
Group:          System/Libraries

Obsoletes:      qscintilla-i18n-qt4 < 2.9.1-2
# Mageia 5
Conflicts:      qscintilla-i18n < 2.8.1-2

%description -n %{libqs4}
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

%files -n %{libqs4}
%{_qt4_libdir}/libqscintilla2.so.%{major}
%{_qt4_libdir}/libqscintilla2.so.%{major}.*
%{_qt4_translationdir}/qscintilla*.qm

#--------------------------------------------------------------

%package -n     %{libqs5}
Summary:        Port to Qt5 of Neil Hodgson's Scintilla C++ editor class
Group:          System/Libraries

Obsoletes:      qscintilla-i18n < 2.9.1-2
# Cauldron (mga6)
Conflicts:      qscintilla-i18n < 2.9.1-2

%description -n %{libqs5}
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

%files -n %{libqs5}
%{_qt5_libdir}/libqscintilla2-qt5.so.%{major}
%{_qt5_libdir}/libqscintilla2-qt5.so.%{major}.*
%{_qt5_translationdir}/qscintilla*.qm

#--------------------------------------------------------------

%package -n     %{libqs5dev}
Summary:        Libraries, include and other files to develop applications with QScintilla for Qt5
Group:          Development/KDE and Qt
Requires:       %{libqs5} = %{version}-%{release}
Provides:       %{name}-qt5-devel = %{version}-%{release}

%description -n %{libqs5dev}
This packages contains the libraries, include and other files
you can use to develop applications with QScintilla.

%files -n %{libqs5dev}
%{_qt5_includedir}/*
%{_qt5_libdir}/libqscintilla2-qt5.so
%{_qt5_prefix}/mkspecs/features/qscintilla2.prf
%{_qt5_plugindir}/designer/*

#--------------------------------------------------------------

%package -n     %{libqs4dev}
Summary:        Libraries, include and other files to develop applications with QScintilla for Qt4
Group:          Development/KDE and Qt
Requires:       %{libqs4} = %{version}-%{release}
Provides:       %{name}-qt4-devel = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
# Mageia 5
Provides:       %{_lib}qscintilla-devel = %{version}-%{release}

Obsoletes:      %{_lib}qscintilla-devel < 2.9.1-2
Obsoletes:      %{_lib}qscintilla-qt4-devel < 2.9.1-2

%description -n %{libqs4dev}
This packages contains the libraries, include and other files
you can use to develop applications with QScintilla.

%files -n %{libqs4dev}
%{_includedir}/Qsci
%{_qt4_prefix}/mkspecs/features/qscintilla2.prf
%{_qt4_libdir}/libqscintilla2.so
%{_qt4_plugindir}/designer/libqscintillaplugin.so

#--------------------------------------------------------------

%package -n     python3-qt5-qscintilla
Summary:        Python3 Qt5 QScintilla bindings
Group:          Development/KDE and Qt
Requires:       python3-qt5
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs5} = %{version}

%description -n python3-qt5-qscintilla
Python3 Qt5 QScintilla bindings.

%files -n python3-qt5-qscintilla 
%{_datadir}/python3-sip/PyQt5/Qsci
%{python3_sitearch}/PyQt5/Qsci.so

#--------------------------------------------------------------

%package -n     python3-qt4-qscintilla
Summary:        Python3 Qt4 QScintilla bindings
Group:          Development/KDE and Qt
Requires:       python3-qt4
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs4} = %{version}

%description -n python3-qt4-qscintilla
Python3 Qt4 QScintilla bindings.

%files -n python3-qt4-qscintilla
%{_datadir}/python3-sip/PyQt4/Qsci
%{python3_sitearch}/PyQt4/Qsci.so

#--------------------------------------------------------------

%package -n     python-qt5-qscintilla
Summary:        Python Qt5 QScintilla bindings
Group:          Development/KDE and Qt
Requires:       python-qt5
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs5} = %{version}

%description -n python-qt5-qscintilla
Python2 Qt5 QScintilla bindings.

%files -n python-qt5-qscintilla
%{_datadir}/sip/PyQt5/Qsci
%{python2_sitearch}/PyQt5/Qsci.so

#--------------------------------------------------------------

%package -n     python-qt4-qscintilla
Summary:        Python Qt4 QScintilla bindings
Group:          Development/KDE and Qt
Requires:       python-qt4
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs4} = %{version}

Obsoletes:      python2-qt4-qscintilla < 2.9.1-2

%description -n python-qt4-qscintilla
Python2 Qt4 QScintilla bindings.

%files -n python-qt4-qscintilla
%{_datadir}/sip/PyQt4/Qsci
%{python2_sitearch}/PyQt4/Qsci.so

#--------------------------------------------------------------

%package        doc-qt5
Summary:        QScintilla docs
Group:          Development/KDE and Qt
BuildArch:      noarch

%description    doc-qt5
QScintilla doc.

%files doc-qt5
%doc NEWS README doc
%{_qt5_prefix}/qsci/api/python/*

#--------------------------------------------------------------

%package        doc
Summary:        QScintilla docs
Group:          Development/KDE and Qt
BuildArch:      noarch

Obsoletes:      qscintilla-doc-qt4 < 2.9.1-2

%description    doc
QScintilla doc.

%files doc
%{_qt4_prefix}/qsci/api/python/*

#--------------------------------------------------------------

%prep 
%setup -qn QScintilla-gpl-%{version}
%patch0 -p1 -b .qt5

%build
### Qt4 build
PATH=%{_qt4_bindir}:$PATH; export PATH

cp -a Qt4Qt5 Qt4/
pushd Qt4
	%{qmake_qt4} qscintilla.pro
	%make
popd

# set QMAKEFEATURES to ensure just built lib/feature is found
QMAKEFEATURES=`pwd`/Qt4/features; export QMAKEFEATURES

cp -a designer-Qt4Qt5 designer-Qt4/
pushd designer-Qt4
	%{qmake_qt4} designer.pro INCLUDEPATH+=../Qt4 LIBS+=-L../Qt4
	%make
popd

cp -a Python Python2-qt4
pushd Python2-qt4
	%{__python2} \
  		configure.py \
    		--no-timestamp \
    		--qsci-incdir=../Qt4 --qsci-libdir=../Qt4

	%make
popd

cp -a Python Python3-qt4
pushd Python3-qt4
	%{__python3} \
  		configure.py \
    		--no-timestamp \
    		--pyqt-sipdir=/usr/share/python3-sip/PyQt4 \
    		--qsci-incdir=../Qt4 --qsci-libdir=../Qt4 \
    		--sip=/usr/bin/python3-sip

	%make
popd

### Qt5 build
PATH=%{_qt5_bindir}:$PATH; export PATH

cp -a Qt4Qt5 Qt5/
pushd Qt5
	%{qmake_qt5} qscintilla.pro
	%make
popd

# set QMAKEFEATURES to ensure just built lib/feature is found
QMAKEFEATURES=`pwd`/Qt5/features; export QMAKEFEATURES

cp -a designer-Qt4Qt5 designer-Qt5/
pushd designer-Qt5
	%{qmake_qt5} designer.pro INCLUDEPATH+=../Qt5 LIBS+=-L../Qt5
	%make
popd

cp -a Python Python2-qt5
pushd Python2-qt5
	%{__python2} \
  		configure.py \
    		--no-timestamp \
    		--pyqt=PyQt5 \
    		--qsci-incdir=../Qt5 --qsci-libdir=../Qt5

	%make
popd

cp -a Python Python3-qt5
pushd Python3-qt5
	%{__python3} \
  		configure.py \
    		--no-timestamp \
    		--pyqt=PyQt5 \
    		--pyqt-sipdir=/usr/share/python3-sip/PyQt5 \
    		--qsci-incdir=../Qt5 --qsci-libdir=../Qt5 \
    		--sip=/usr/bin/python3-sip

	%make
popd

%install
### Qt4 install
make -C Qt4 install INSTALL_ROOT=%{buildroot}
make -C designer-Qt4 install INSTALL_ROOT=%{buildroot}

make -C Python2-qt4 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python2_sitearch}/PyQt4/Qsci.so || \
chmod a+x %{buildroot}%{python2_sitearch}/PyQt4/Qsci.so
make -C Python3-qt4 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python3_sitearch}/PyQt4/Qsci.so || \
chmod a+x %{buildroot}%{python3_sitearch}/PyQt4/Qsci.so

### Qt5 install
make -C Qt5 install INSTALL_ROOT=%{buildroot}
make -C designer-Qt5 install INSTALL_ROOT=%{buildroot}

make -C Python2-qt5 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python2_sitearch}/PyQt5/Qsci.so || \
chmod a+x %{buildroot}%{python2_sitearch}/PyQt5/Qsci.so
make -C Python3-qt5 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python3_sitearch}/PyQt5/Qsci.so || \
chmod a+x %{buildroot}%{python3_sitearch}/PyQt5/Qsci.so


%changelog
* Thu Sep 29 2016 joequant <joequant> 2.9.1-7.mga6
+ Revision: 1057584
- need rebuild to pick up new qt5

* Tue Feb 16 2016 umeabot <umeabot> 2.9.1-6.mga6
+ Revision: 962530
- Mageia 6 Mass Rebuild

* Sat Nov 14 2015 daviddavid <daviddavid> 2.9.1-5.mga6
+ Revision: 903090
- obsoletes some incorrect subpackages < 2.9.1-2

* Mon Nov 09 2015 ns80 <ns80> 2.9.1-4.mga6
+ Revision: 899908
- fix python3-qt4-devel build requirement

* Mon Nov 09 2015 ns80 <ns80> 2.9.1-3.mga6
+ Revision: 899901
- put Qt4 related headers in Qt4 related devel package

  + daviddavid <daviddavid>
    - fix requires on qscintilla2-devel subpackage

* Sun Nov 08 2015 akien <akien> 2.9.1-2.mga6
+ Revision: 899258
- Add missing python-qt5 package
- Rename lib packages to match their actual lib names
- Put translation files directly in the lib packages to get rid of i18n subpackages
- Rename python2-qt4-qscintilla to python-qt4-qscintilla

* Sun Nov 08 2015 neoclust <neoclust> 2.9.1-1.mga6
+ Revision: 899213
- New version 2.9.1

* Wed Sep 09 2015 neoclust <neoclust> 2.9-4.mga6
+ Revision: 874750
- Fix provides

* Wed Sep 09 2015 neoclust <neoclust> 2.9-3.mga6
+ Revision: 874715
- Build more with qt5

* Wed Sep 09 2015 fwang <fwang> 2.9-2.mga6
+ Revision: 874675
- qt5 flavour does not build now
- use correct qmake
- update sip dir
- update sysroot
- add more br
- set qt5 as default
- simplified br
- br qt5
- use correct macro
- fix br
- add py3qt5 flavour

* Wed Sep 09 2015 fwang <fwang> 2.9-1.mga6
+ Revision: 874589
- update file list
- 2.9
- 2.8.2

  + umeabot <umeabot>
    - Second Mageia 5 Mass Rebuild
    - Mageia 5 Mass Rebuild

  + tv <tv>
    - rebuild for missing pythoneggs deps

* Mon Mar 17 2014 fwang <fwang> 2.8.1-1.mga5
+ Revision: 604319
- update file list
- fix linkage
- 2.8.1

* Tue Feb 04 2014 fwang <fwang> 2.8-1.mga5
+ Revision: 581702
- update lib major
- new version 2.8

* Sat Oct 19 2013 umeabot <umeabot> 2.7.2-4.mga4
+ Revision: 528936
- Mageia 4 Mass Rebuild

  + fwang <fwang>
    - qscintilla does not support build python2 and python3 flavour at the same time
    - build py3 sip
    - build python3 flavour

* Sat Jun 29 2013 fwang <fwang> 2.7.2-2.mga4
+ Revision: 448375
- move translations out of lib package

* Tue Jun 18 2013 fwang <fwang> 2.7.2-1.mga4
+ Revision: 444336
- update file list
- update file list
- update install prefix
- update dir
- fix ver
- new version 2.7.2

* Sun Jan 13 2013 umeabot <umeabot> 2.7-5.mga3
+ Revision: 379912
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Dec 16 2012 fwang <fwang> 2.7-4.mga3
+ Revision: 331414
- fix obsoletes and conflicts tag

* Tue Dec 11 2012 matteo <matteo> 2.7-3.mga3
+ Revision: 329742
- obsoleting lib qscintilla2_8

* Tue Dec 11 2012 matteo <matteo> 2.7-2.mga3
+ Revision: 329693
- added missing conflict definition

* Tue Dec 11 2012 matteo <matteo> 2.7-1.mga3
+ Revision: 329646
- new version

* Sat Dec 08 2012 fwang <fwang> 2.6.2-2.mga3
+ Revision: 328051
- requires sip api

* Tue Jun 26 2012 fwang <fwang> 2.6.2-1.mga3
+ Revision: 263945
- update includepath
- fix dir
- upload taball
- new version 2.6.2

* Sun Feb 26 2012 matteo <matteo> 2.6.1-1.mga2
+ Revision: 215220
- new version

* Sun Feb 26 2012 matteo <matteo> 2.6-5.mga2
+ Revision: 215162
- fixed wrong qt4 macro
- rebuild needed after pyqt upgrade

* Tue Dec 27 2011 fwang <fwang> 2.6-4.mga2
+ Revision: 188115
- update file list

  + dmorgan <dmorgan>
    - Use new qt4 macros

* Mon Dec 26 2011 fwang <fwang> 2.6-3.mga2
+ Revision: 187733
- more accurate obsoletes

* Mon Dec 26 2011 fwang <fwang> 2.6-2.mga2
+ Revision: 187704
- update libmajor
- correct libname

* Mon Dec 26 2011 fwang <fwang> 2.6-1.mga2
+ Revision: 187684
- new version 2.6

* Fri Jul 01 2011 fwang <fwang> 2.5.1-1.mga2
+ Revision: 117090
- new version 2.5.1

* Fri Jan 21 2011 ahmad <ahmad> 2.4.6-2.mga1
+ Revision: 28790
- use the current qt4 Epoch in the qt4-devel BR
- remove the with_qt3 bits; qt3 package wasn't built for a long time anyway
- imported package qscintilla

